(*
 * F-ing Modules with Coq
 *
 * (c) 2009 Andreas Rossberg & Claudio Russo
 *)

Require Import Metatheory.
Require Import Metatheory_Misc.
Require Import AdditionalTactics.
Require Import Misc.
Require Import Fomega.
Require Import Derived.
Require Import Modules_syntax.
Require Import Modules_semantic.
Require Import Modules_elaboration.


(*************************************************************************)
(* Soundness of  Matching *)
(*************************************************************************)

Hint Constructors okD.
Hint Constructors okG.


Lemma openingsAT: forall ts L D t k ks,
  (forall as', fresh L (length ks) as' -> ofT (D & as' ~~ ks ) (opensAT (freeTs as') t) k) ->
  (length ks = length ts)->
   (forall (t : typ) , forall (k : knd), In (pair t k) (combine ts ks) -> ofT D t k) ->
  ofT D (opensAT ts t) k.
Proof.
  induction ts as [| t' ts'].
  Case "ts = nil".
  intros L D t k ks.
  intros H lenksislents H1.
  assert (ks = nil) as ksnil.
  apply (length_zero_is_nil _ _ lenksislents).
  subst ks.
  apply (H nil).
  auto.
  Case "ts = t'::ts'".
  intros L D t k ks . 
  intros H lenksislents H1.
  assert ( exists k, exists ks', ks = k::ks') as ksiscons.
  apply (length_succ_is_cons _ _ _ lenksislents).
  destruct ksiscons as [k' H2].
  destruct H2 as [ks' H3].
  subst ks.
  simpl opensAT.
  pick_freshes_gen (L \u dom(D) \u varsAT t) (length (k'::ks')) a'as'.
  assert (length a'as' = length (k'::ks')) as lena'as'.
  symmetry.
  apply (fresh_length _ _ _ Fr).
  assert ( exists a', exists as', a'as' = a'::as') as a'as'iscons.
  apply (length_succ_is_cons _ _ _ lena'as').
  destruct a'as'iscons as [a' [as' H3]].
  subst a'as'.
  rewrite substAT_opensAT.
  assert (ofT (D & a' ~ k' & (as' ~~ ks')) (opensAT (freeTs (a'::as')) t) k).
  rewrite -> concat_assoc.
  rewrite <- concat_multi_cons.
  eapply H.
  assert (Frl := (fresh_union_r _ _ _ _ Fr)).
  destruct Frl as [Frl _].
  assert (Frll := (fresh_union_r _ _ _ _ Frl)).
  auto*.
  assert (ofT (D & (as' ~~ ks')) (substAT a' t' (opensAT (freeTs (a'::as')) t)) k). 
  apply (substitutabilityAT D a' (as'~~ks') t' k' (opensAT (freeTs (a':: as')) t) k).
  apply H0.
  apply weakeningDT_head.
  apply H1.
  simpl.
  left.
  reflexivity.
  apply okD_vars.
  assert (okDa'as' := validityDT _ _ _ H0).
  rewrite concat_assoc in okDa'as'.
  apply (validityDD_split _ _ okDa'as').
  simpl fresh in Fr.
  destruct Fr as [Fra Fras'].
  fresh_solve.
  simpl opensAT in H2.
  rewrite <- substAT_bnd_as_substAT_free in H2.
  rewrite substAT_opensAT in H2.
  eapply (IHts' L D (substAT (length ts') t' t) k ks'). 
  intros bs Frbs.
  pick_fresh_gen (L \u dom(D) \u varsAs bs \u varsAT t )  b. 
  assert (ofT (D & (b::bs) ~~ (k' :: ks')) (opensAT (freeTs (b::bs)) t) k).
  apply (H (b::bs)).
  simpl fresh.
  split.
  auto.
  apply fresh_union_l.
  exact Frbs.
  rewrite (fresh_length _ _ _ Frbs).
  apply fresh_single.
  auto.
  auto.
  rewrite <- substAT_opensAT. 
  rewrite (substAT_bnd_as_substAT_free b t' (length ts') (opensAT (freeTs bs) t)).
  assert (length ts' = length (freeTs bs)) as rwlents'.
  unfold freeTs.
  rewrite map_length; rewrite map_length. 
  rewrite <- (fresh_length _ _ _ Frbs).
  inversion lenksislents; auto.
  rewrite rwlents'.
  apply (substitutabilityAT D b (bs~~ks') t' k' (opensAT (freeTs (b:: bs)) t) k).
  rewrite concat_assoc.
  rewrite <- concat_multi_cons.
  auto.
  apply weakeningDT_head.
  apply H1.
  left.
  reflexivity.
  apply okD_vars.
  refine (validityDT _ _ _ (H1 t' k' _ )).
  left.
  reflexivity.
  rewrite concat_multi_cons in H3.
  rewrite <- (concat_assoc D (b~k') (bs~~ks')) in H3.
  assert (okDbbs :=  validityDT _ _ _ H3). 
  assert (okD (D & b ~ k') /\ fresh (dom (D & b ~ k')) (length bs) bs).
  apply (okD_vars_inv bs ks').
  symmetry.
  apply (fresh_length _ _ _ Frbs).
  exact okDbbs.
  destruct H4.
  simpl dom in H5.
  rewrite (fresh_length _ _ _ Frbs).
  fresh_solve.
  eapply notin_varsAT_opensAT with (L := dom D).
  rewrite concat_multi_cons in H3.
  rewrite <- concat_assoc in H3.
  assert (okDbbs :=  validityDT _ _ _ H3). 
  assert (okD (D & b ~ k') /\ fresh (dom (D & b ~ k')) (length bs) bs).
  apply (okD_vars_inv bs ks').
  symmetry.
  apply (fresh_length _ _ _ Frbs).
  exact okDbbs.
  destruct H4.
  simpl dom in H5.
  rewrite union_comm.
  apply H5.
  fresh_solve. 
  unfold freeTs.
  rewrite map_length.
  rewrite map_length.
  rewrite <- (fresh_length _ _ _ Frbs).
  inversion lenksislents.
  omega.
  refine (regularityT _ _ _ (H1 t' k' _ )).
  left; reflexivity.
  apply lclosedTs_vars.
  (* this is repeated from above! refactor *)
  inversion lenksislents.
  auto.
  intros; apply H1; right; auto.
  omega.
  refine (regularityT _ _ _ (H1 t' k' _ )).
  left; reflexivity.
  fold (freeTs as').
  apply lclosedTs_vars.
  fold (freeTs as').
  eapply notin_varsAT_opensAT with (L := dom D).
  simpl fresh in Fr.
  destruct Fr as [Fra' Fras'].
  eauto.
  notin_solve.
  omega.
  refine (regularityT _ _ _ (H1 t' k' _)).
  left. 
  reflexivity.
  eapply (regularityTs D ts' ks').
  inversion lenksislents; reflexivity.
  intros to ko In.
  apply (H1 to ko).
  right.
  apply In.
Qed.


Theorem sound_enrich :
  (forall C s s' ks ts e,
   matchS C s s' ks ts e ->
   forall L,
   ofT C  (transS s) omK ->
   (forall bs, fresh L (length ks) bs -> ofT (C & bs ~~ ks)  (opensAT (freeTs bs) (transS s')) omK )->
   ofE C empty e (arrT (transS s) (opensAT ts (transS s')))) /\
  (forall C s s' e,
   enrichS C s s' e ->
   ofT C  (transS s) omK ->
   ofT C  (transS s') omK ->
   ofE C empty e (arrT (transS s) (transS s'))) /\
  (forall C r r' re,
   enrichR C r r' re ->
   forall L,
   ofT C  (strT (transR r)) omK ->
   ofT C  (strT (transR r')) omK ->
   (forall x, x \notin L -> ofER C (x ~ strT (transR r)) (openXER x re ) (transR r'))) /\ 
  (forall C q q' e,
   enrichQ C q q' e ->
   ofT C  (transQ q) omK ->
   ofT C  (transQ q') omK ->
   ofE C empty e (arrT (transQ q) (transQ q'))).
Proof.
  apply IImatch.
  Case "matchS_enrich".
    intros C s s' ks ts f lenks_is_lents ofTtsks H1 IH1 L0 ofTq ofTq'.
    assert  (transS (opensAS ts s') = opensAT ts (transS s')) as Eq.
     rewrite opensAT_transS. 
     reflexivity.
     apply (regularityTs C ts ks);auto.
    rewrite <- Eq.
    apply IH1.
    exact ofTq.
    pick_freshes_gen (dom(C) \u L0 \u varsAT (transS s')) (length ks) bs.
    assert (ofT (C & bs ~~ ks) (opensAT (freeTs bs) (transS s')) omK) as ofTq'_at_bs.
      apply* ofTq'.
    rewrite  <- opensAT_transS.
    apply* (openingsAT ts L0 C (transS s') omK ks).
    apply (regularityTs C ts ks);auto.
  Case "enrichS_val".
    intros C t t' ofTt ofTt' eqtt' ofTs ofTs'.
    simpl transS.
    apply* (ofE_lam {}).
      intros x Frx.
      apply (ofE_sub C ( empty & x ~ t ) x t t'); auto*.
      apply* (ofE_var). 
      apply* okG_var.
      apply* okG_empty.
      apply (validityDT _ _ _ ofTs).
  Case "enrichS_typ".
    intros C t t' k okt okt' eqtt' ofTs ofTs'.
    simpl transS.
    apply* (ofE_lam {}).
    intros x Frx.
    apply (ofE_sub C ( empty & x ~ transS (typS t k) ) x (transS (typS t k)) (transS (typS t' k))).
    apply ofE_var.
    apply* okG_var.
    apply* okG_empty.
    apply (validityDT _ _ _ ofTs).
    auto*.
    apply ofTs'.
    simpl.
    apply* eqT_typ.
  Case "enrichS_sig".         
    intros C q q' f f' P1 IH1 P2 IH2 ofTtrq ofTtrq'.
    simpl transS.
    apply* (ofE_lam {}).
    intros x Frx.
    rewrite openXE_typ.
    apply ofE_typ.
    simpl transS in ofTtrq.
    apply* okG_var.
    apply* okG_empty.
    apply (validityDT _ _ _ ofTtrq).
    simpl transS in ofTtrq'.
    apply (ofT_typ_inversion).
    apply (lclosedT_typ_inversion (transQ q') omK).
    eapply regularityT.
    apply ofTtrq'.
    apply ofTtrq'.
    auto*.
    simpl transS in ofTtrq'.
    apply (lclosedT_typ_inversion (transQ q') omK).
    eapply regularityT.
    apply ofTtrq'.
  Case "enrichS_str".
    intros C r r' re Hr Hr' H1 IH1 ofTr ofTr'.
    apply (ofE_lam {}).
    exact ofTr.
    intros x xFr.
    simpl transS.
    rewrite openXE_str.
    apply ofE_str.
    apply (IH1  {} ofTr ofTr'  x xFr).
 Case "enrichS_fun". (* that's quite a goal *)
    Focus 1.
    intros L C ks s q ks' s' q' ts f1 f2.
    intros HDom IHDom.
    intros HRng IHRng.
    intros ofTf ofTf'.
    simpl transS in ofTf.
    set (ofTf_inv := ofT_alls_inversion _ _ _ ofTf).
    destruct ofTf_inv as [Lf Pf].
    simpl transS in ofTf'.
    set (ofTf'_inv := ofT_alls_inversion _ _ _ ofTf').
    destruct ofTf'_inv as [Lf' Pf'].
    assert (okD C) as okC.
      apply (validityDT _ _ _ ofTf).
    assert (ofT C (allsT ks (arrT (transS s) (transQ q))) omK) as ofT_lhs. (*TODO: this may be redudant with ofTf ! *)
      apply ofTf.
    simpl transS. 
    apply (ofE_lam (L \u Lf \u Lf' \u varsXE f2 \u varsXE f1)).
     exact ofT_lhs.
     intros x xFr.
     assert (okG C (empty & x ~ allsT ks (arrT (transS s) (transQ q)))) as okCx.
       apply okG_var. apply okG_empty. exact okC. fresh_solve. apply ofT_lhs.
     rewrite openXE_gens.
     eapply (ofE_gens (L \u Lf \u Lf' \u dom(C))).
      apply okCx.
     intros as' FrAs'.
      assert (matchS (C & as' ~~ ks') (opensAS (freeTs as') s') s ks
              (map (opensAT (freeTs as')) ts) (opensAE (freeTs as') f1)) as HDom_conc.
       eapply HDom.
       fresh_solve.
      assert (ofT (C & as' ~~ ks') (opensAT (freeTs as') (arrT (transS s') (transQ q'))) omK) as Pf'_for_as'.
        apply* Pf'. rewrite opensAT_arr in Pf'_for_as'.
      assert (ofE (C & as' ~~ ks') empty (opensAE (freeTs as') f1)
            (arrT (transS (opensAS (freeTs as') s'))
               (opensAT (map (opensAT (freeTs as')) ts) (transS s)))) as IHDom_conc.
       assert (fresh L (length ks') as') as FrLas'.
        fresh_solve.
       eapply (IHDom as' FrLas' (L \u Lf \u Lf' \u dom(C & as' ~~ ks'))).
        rewrite <- opensAT_transS.
        2: apply lclosedTs_vars.
        inversion Pf'_for_as'. assumption.
        intros bs FrLbbs.
         apply weakeningDT. 
            assert (ofT (C & bs ~~ ks) (opensAT (freeTs bs) (arrT (transS s) (transQ q))) omK) as Pf_for_bs.
              apply* Pf. 
              rewrite opensAT_arr in Pf_for_bs.
            inversion Pf_for_bs. assumption.
              apply okD_vars; auto*.
              apply okD_vars; auto*.
      assert ( ofE (C & as' ~~ ks') empty (opensAE (freeTs as') f2)
            (arrT (transQ (opensAQ (map (opensAT (freeTs as')) ts) q))
               (transQ (opensAQ (freeTs as') q')))) as IHRng_conc.
       eapply IHRng. fresh_solve.
       rewrite <- opensAT_transQ.
       inversion HDom_conc.
         assert (ofT (C & as' ~~ ks') (allsT ks (arrT (transS s) (transQ q))) omK) as OfTfweak.
           apply* weakeningDT_head.
           apply (validityDT _ _ _ Pf'_for_as').
         assert (OfTfweak_inv := ofT_alls_inversion _ _ _ OfTfweak).
         destruct OfTfweak_inv as [Lf'' ofTfweak_inv].
         assert ( OfTfweak_inst : ofT (C & as' ~~ ks') (opensAT (map (opensAT (freeTs as')) ts) (arrT (transS s) (transQ q))) omK).
           apply* (openingsAT (map (opensAT (freeTs as')) ts) Lf'' (C & as'~~ks') (arrT (transS s) (transQ q)) omK ks).
         rewrite opensAT_arr in OfTfweak_inst.
         inversion OfTfweak_inst.
         auto.
         inversion HDom_conc; eapply regularityTs; eauto.
         rewrite <- opensAT_transQ.
         2: apply lclosedTs_vars.
         inversion Pf'_for_as';auto.
      assert (ofT (C & as' ~~ ks') (arrT (transS (opensAS (freeTs as') s'))
                                   (opensAT (map (opensAT (freeTs as')) ts) (transS s))) omK) as IHDom_conc_reg.
        eapply validityTE. apply IHDom_conc.
      assert ( ofT (C & as' ~~ ks') 
                (arrT (transQ (opensAQ (map (opensAT (freeTs as')) ts) q))
                      (transQ (opensAQ (freeTs as') q'))) 
                omK) as IHRng_conc_reg.
        eapply validityTE. apply IHRng_conc.
      unfold openXE.
      rewrite <- substXE_opensAE.
       2: apply lclosedE_var.
      rewrite opensAE_lam.
      rewrite opensAE_app. 
      rewrite opensAE_app. 
      rewrite opensAE_app. 
      simpl substXE.
      rewrite (substXE_lclosed 1 x (opensAE (freeTs as') f2)).
       2: (eapply regularityE; apply IHRng_conc).
      rewrite (substXE_lclosed 1 x (opensAE (freeTs as') f1)).
       2: (eapply regularityE; apply IHDom_conc).
      rewrite substXE_opensAE.
       2: (apply lclosedE_var).
      rewrite substXE_opensAE.
       2: (apply lclosedE_var).
      rewrite substXE_insts.
      simpl substXE.
      rewrite opensAT_arr.
      apply (ofE_lam ((L \u dom(C)) \u {{x}})).
        rewrite opensAT_transS.
        inversion IHDom_conc_reg. 
        assumption.
        apply lclosedTs_vars.
      intros y yFr.
      assert (okG (C & as' ~~ ks')
                  (empty & x ~ allsT ks (arrT (transS s) (transQ q)))) as okCas'x.
        apply weakeningDG_head. 
         apply okCx. 
         apply okD_vars. 
         exact okC.
        fresh_solve. 
      assert (okG (C & as' ~~ ks')
                  (empty & x ~ allsT ks (arrT (transS s) (transQ q)) &
                   y ~ opensAT (freeTs as') (transS s'))) as okCas'xy.
       apply okG_var. 
        apply okCas'x.
        fresh_solve. 
        rewrite opensAT_transS. 
         inversion IHDom_conc_reg; assumption.
         apply lclosedTs_vars.
      unfold openXE.
      simpl substXE.
      rewrite (substXE_lclosed 0 y (opensAE (freeTs as') f2)).
       2: (eapply regularityE; apply IHRng_conc).
      rewrite (substXE_lclosed 0 y (opensAE (freeTs as') f1)).
       2: (eapply regularityE; apply IHDom_conc).
      rewrite substXE_opensAE.
       2: (apply lclosedE_var).
      rewrite substXE_opensAE.
       2: (apply lclosedE_var).
      rewrite substXE_insts.
      simpl substXE.
      eapply ofE_app with (t2 := (transQ (opensAQ (map (opensAT (freeTs as')) ts) q))) .
      rewrite opensAT_transQ with (q:=q').
       2: apply lclosedTs_vars.
      apply weakeningGE_head.
       2: exact okCas'xy.
      apply weakeningGE_head.
       2: exact okCas'x.
      exact IHRng_conc.
      eapply ofE_app with (t2 := (opensAT (map (opensAT (freeTs as')) ts) (transS s))).
      rewrite opensAE_insts.
      rewrite opensAE_lclosed.
       2: apply lclosedE_var.
      rewrite <- opensAT_transQ.
      rewrite  <- opensAT_arr.
      eapply ofE_insts with (ks:=ks).
       auto*.
       inversion HDom_conc; assumption.
       inversion HDom_conc; assumption.
       inversion HDom_conc; eapply regularityTs; eauto.
      eapply ofE_app.
      apply weakeningGE_head.
      apply weakeningGE_head.
      eapply IHDom_conc.
      exact okCas'x.
      exact okCas'xy.
      rewrite opensAE_lclosed.
       2: apply lclosedE_var.
      rewrite <- opensAT_transS.
       2: apply lclosedTs_vars. 
      auto*.
 Case "enrichR_emp". 
  intros C r lclosedRr L ofT_tr_r ofT_trEmpR x xnotinL.
  simpl.
  apply ofER_nil.
  change (okG C (empty & x ~ strT (transR r))).
  apply okG_var.
  apply okG_empty.
  apply (validityDT _ _ _ ofT_tr_r).
  fresh_solve.
  exact ofT_tr_r.
Case "enrichR_add".
  intros C l s r s' r' f re field_l_s_r enrichSss' H enrichrr' H0 L.
  intros ofT_lsr.
  intros ofT_ls'r'.
  intros x freshLx.
  assert (field_l_tr_s_tr := @field_trans l s r field_l_s_r) .
  simpl.
  rewrite openXER_cons.
  apply ofER_cons.
  unfold openXE.
  simpl.
  apply (ofE_app C (x ~ strT (transR r)) (substXE 0 x f ) (substXE 0 x (dotE (transR r) l 0)) (transS s) (transS s')).
   (* f *)
    assert (ofE C (empty & x ~ strT (transR r)) f (arrT (transS s) (transS s'))) as Hconc.
     apply weakeningGE_head.
     apply H.
     eapply ofT_field.
     apply (ofT_str_inversion _ _  ofT_lsr).
     apply field_l_s_r.
     simpl transR in ofT_ls'r'.
     inversion ofT_ls'r'; auto.
     apply okG_var.
     apply okG_empty. 
     apply (validityDT C (strT (transR r)) omK ofT_lsr).
     fresh_solve.
     apply ofT_lsr.
    change (ofE C (empty & x ~ strT (transR r)) (substXE 0 x f) (arrT (transS s) (transS s'))).
    rewrite substXE_lclosed.
    apply Hconc.
    apply (regularityE _ _ _ _ Hconc).
    (* dotE (transR r l x) *)
    rewrite substXE_dot.
    apply ofE_dot.
    simpl.
    apply ofE_var.
    change (okG C (empty & x ~ strT (transR r))).
    apply okG_var.
    apply okG_empty.
    apply (validityDT _ _ _ ofT_lsr).
    fresh_solve.
    apply ofT_lsr.
    change ( binds x (strT (transR r)) (empty & x ~ strT (transR r))).
    apply binds_head.
    exact field_l_tr_s_tr.
    eapply H0.
    auto.
    simpl transR in ofT_ls'r'.
    assert (ofTRls'r':= ofT_str_inversion  _ _  ofT_ls'r').
    inversion ofTRls'r'.
    apply ofT_str.
    apply H6.
    apply freshLx.
Case  "enrichQ". 
        intros L C ks s ks' s' ts f e.
        intros He H IH.
        intros ofTq ofTq'.
        (* invert ofTq *)
        simpl transQ in ofTq.
        set (ofTq_inv := ofT_exs_inversion _ _ _ ofTq).
        destruct ofTq_inv as [Lq Pq].
        (* invert ofTq' *)
        simpl transQ in ofTq'.
        set (ofTq'_inv := ofT_exs_inversion _ _ _ ofTq').
        destruct ofTq'_inv as [Lq' Pq'].
        assert (okD C) as okC.
         apply (validityDT _ _ _ ofTq).
        apply (ofE_lam (L \u Lq \u Lq' \u varsXE f)). 
         apply ofTq.
        intros x xFr.
        assert (okG C (empty & x ~ transQ (exQ ks s))) as okCx.
          apply okG_var. apply okG_empty. exact okC. fresh_solve. apply ofTq.
        rewrite openXE_unpacks.
         unfold openXE.
         simpl substXE.
        eapply (ofE_unpacks ks (L \u Lq \u Lq' \u dom(C) \u {{x}} \u varsXE f)).
         3: apply ofTq'.
         auto.
        intros as' y as'Fr yFr.
        assert (matchS (C & as' ~~ ks) (opensAS (freeTs as') s) s' ks'
                 (map (opensAT (freeTs as')) ts) (opensAE (freeTs as') f)) as Hconc.
          apply (H as').
          fresh_solve.
        inversion Hconc.
        subst. (* clear up junk left by inversion *)
        (* Now I think we should push opensAE (freeTs as') down into appE
           so that we can ultimately apply ofT_packsE and the conclusion of IH - which
           gives us the type of (opensAE (freeTs as') f. 
           However, we also need to push openXE y down to 0 and delete substXE ... x (...).
           Since we assumed x fresh for f and y fresh for x, we can remove
           the substition for x. NB x occurred in the lhs of the original opens,
           not the rhs we are in now.
        *)
        assert (ofE (C & as' ~~ ks) empty (opensAE (freeTs as') f)
         (arrT (transS (opensAS (freeTs as') s))
            (opensAT (map (opensAT (freeTs as')) ts) (transS s')))) as IHconc.
         assert (fresh L (length ks) as') as Fras'L.
           fresh_solve.
         eapply (IH as' Fras'L (L \u dom(C & as' ~~ ks) \u Lq')).
          rewrite <- opensAT_transS.
          apply Pq.
          fresh_solve.
          apply lclosedTs_vars.
          intros bs' frBs.
           apply weakeningDT.
           apply Pq'.
           fresh_solve.
           apply okD_vars.
           apply okD_vars.
           apply okC.
           fresh_solve.
           fresh_solve.
        assert (okG (C & as' ~~ ks) 
                    (empty & x ~ exsT ks (transS s) &
                     y ~ opensAT (freeTs as') (transS s))) as okCas'xy.
         apply* okG_var. 
          apply* okG_var.
          apply* okG_empty.
          apply* okD_vars.
          apply weakeningDT_head.
           apply ofTq.
           apply* okD_vars.
        rewrite <- substXE_opensAE.
        2: apply lclosedE_var.
        rewrite (He as').
        2: fresh_solve.
        rewrite opensAE_app.
        rewrite (opensAT_lclosed (exsT ks' (transS s'))).
        2: apply (regularityT _ _ _ ofTq').
        rewrite openXE_substXE.
        2: discriminate.
        2: unfold indepXE; apply lclosedE_var.
        2: apply lclosedE_var.
        unfold openXE.       
        rewrite substXE_packs.
        2: symmetry; apply H0. 
        simpl substXE.
        rewrite (substXE_lclosed 0 y).
        2: eapply (regularityE _ _ _ _ IHconc).
        rewrite substXE_opensAE. 
        2: apply lclosedE_var.
        simpl (substXE 0 y 0).
        rewrite substXE_packs.
        2: symmetry; apply H0.
        simpl transQ.
        apply (ofE_packs).
        symmetry; apply H0. 
        apply H1.
        simpl substXE.
        rewrite substXE_lclosed.
        2: apply (regularityE _ _ _ _ IHconc).
        rewrite substXE_opensAE.
        2: apply lclosedE_var.
        rewrite substXE_lclosed.
        2: apply lclosedE_var.
        eapply ofE_app.
        apply weakeningGE_head.
        apply weakeningGE_head.
        assert (fresh L (length ks) as') as Fras'L.
         fresh_solve.
        eapply (IH as' Fras'L (L \u dom(C & as' ~~ ks) \u Lq')).
        rewrite <- opensAT_transS.
        apply Pq. 
         fresh_solve.
        apply lclosedTs_vars.
        intros bs' frBs.
         apply weakeningDT.
         apply Pq'.
         fresh_solve.
         apply okD_vars.
         apply okD_vars.
         apply okC.
         fresh_solve.
         fresh_solve.
        apply* okG_var.        
         apply* okG_empty.
        apply* okD_vars.        
         apply weakeningDT_head.
         apply ofTq.
         apply* okD_vars.
        apply okCas'xy.
        rewrite opensAE_lclosed.
         2: apply lclosedE_var.
         apply ofE_var.
          apply okCas'xy.
         rewrite opensAT_transS.
          auto.
         apply lclosedTs_vars.
        apply weakeningDT_head.
         apply ofTq'.
         apply okD_vars.
         apply okC.
         fresh_solve.
Qed.



